/**
 * Ein Wrfelspiel mit fnf Wrfeln.
 * 
 * @author Bernd Gramlich 
 * @version 2013-01-18
 */
public class Spiel
{
    /*
     * Das Feld mit (fnf) Wrfeln.
     */
    private Wuerfel[] spielwuerfel;
    
    /*
     * Das Wrfelergebnis als Anzahl der 1er, 2er, ..., 6er.
     */
    private int[] anzahl;

    /**
     * Konstruktor.
     * Wir erzeugen das Feld mit den fnf Wrfeln und
     * platzieren die Wrfel passend auf der Leinwand.
     */
    public Spiel()
    {
        /*
         * Erzeuge das Feld mit den fnf Wrfeln.
         */
        spielwuerfel = new Wuerfel[5];
        
        /*
         * Erzeuge die fnf Wrfel einzeln nebeneinander auf der Leinwand.
         */
        int i;
        
        for (i = 0; i <= 4; i++)
        {
            // Erzeuge Spielwrfel mit der Nummer i.
            spielwuerfel[i] = new Wuerfel (120*i + 20, 20, "lila", "schwarz");
        }
        
        /*
         * Die Wrfelanzahlen sind nummeriert von 1 bis 6.
         */
        anzahl = new int[7];
        
        /*
         * Werte das angezeigte Wrfelergebnis aus.
         */
        werteAus ();
    }
    
    /**
     * Wrfle mit allen fnf Spielwrfeln.
     */
    public void wuerfle ()
    {
        for (int i = 0; i <= 4; i++)
        {
            /*
             * Wrfle den Spielwrfel mit der Nummer i.
             */
            spielwuerfel[i].wuerfle ();
        }
        
        werteAus ();
    }
    
    /**
     * Gib fr alle Wrfel die Statistik aus.
     */
    public void druckeStatistik ()
    {
        int i;
        
        for (i = 0; i <= 4; i++)
        {
            /*
             * Gib die Statistik des Spielwrfels mit der Nummer i aus.
             */
            System.out.println ();
            System.out.println ("Wrfel " + i + ":");
            spielwuerfel[i].druckeStatistik ();
        }
    }
    
    /**
     * Werte den Wurf aus, d. h. zhle, wie oft jede Augenzahl geworfen wurde.
     * 
     * anzahl[1] ist die Anzahl der 1er,
     * anzahl[2] ist die Anzahl der 2er usw.
     */
    private void werteAus ()
    {  
        /*
         * Setze die Anzahl der 1er, 2er, 3er, ... jeweils auf 0.
         */       
        for (int j = 1; j <= 6; j++)
        {
            anzahl[j] = 0;
        }
        
        /*
         * Frage von jedem Wrfel (0 bis 4) jeweils die Augenzahl ab.
         * Erhhe die Anzahl des Vorkommens dieser Augenzahl um 1.
         */
        for (int i = 0; i <= 4; i++)
        {
            anzahl[spielwuerfel[i].gibAugenzahl ()] ++;
        }
    }
    
    /**
     * Gib an, ob ein Drilling vorkommt.
     */
    public boolean hatDrilling ()
    {
        boolean gefunden = false;
        
        for (int j = 1; j <= 6; j++)
        {
            if (anzahl[j] >= 3)
            {
                gefunden = true;
            }
        }
        
        return gefunden;
    }
}
